> For the complete documentation index, see [llms.txt](https://docs.namiml.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.namiml.com/sdk-reference/namipurchasemanager/restorepurchases.md).

# restorePurchases

{% hint style="info" %}
**Apple SDK only**

This method is only available from the Nami SDK for Apple devices, or cross-platform SDKs being used on Apple devices.
{% endhint %}

Restore replays all prior purchase transactions to determine which purchases are active. This function trigger an app store password prompt if called, so only call this at the request of the user.

Generally this is not needed if your Nami account supports purchase validation, as the receipt is checked every time the app comes to the foreground and can determine active purchases that way.

Learn more in our guide on [Restoring Purchases](doc:restoring-purchases) .

Activate the system restore purchases feature. Optionally calls back to a global `NamiRestorePurchasesStateHandler` handler with restore state if one is provided by\
`registerRestorePurchasesHandler`.

{% tabs %}
{% tab title="Swift" %}

```swift
NamiPurchaseManager.restorePurchases()
```

{% endtab %}

{% tab title="Flutter" %}

```Text
// Coming soon
```

{% endtab %}

{% tab title="React Native" %}

```Text
// Coming soon
```

{% endtab %}

{% tab title="Unity" %}

```Text
NamiPurchaseManager.RestorePurchases(); // Apple only
```

{% endtab %}
{% endtabs %}

Activate the system restore purchases feature and call back to the provided completion handler:

{% tabs %}
{% tab title="Swift" %}

```swift
NamiPurchaseManager.restorePurchases() { state, newPurchases, oldPurchases, error in
  // react to restore purchase process
}
```

{% endtab %}

{% tab title="Flutter" %}

```c
// coming soon
```

{% endtab %}

{% tab title="React Native" %}

```Text
// coming soon
```

{% endtab %}

{% tab title="Unity" %}

```c
NamiPurchaseManager.RestorePurchases(restorePurchasesCallback); // Apple only
```

{% endtab %}
{% endtabs %}

**Parameters**

* `state` - of the Restore purchase process
* `newPurchases` - array of all purchases that are active after restore purchase process ran
* `oldPurchases` - array of purchases that were active before the restore purchase process started
* `error` - error returned by the restore purchase process


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.namiml.com/sdk-reference/namipurchasemanager/restorepurchases.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
